

// OPERATOR: /(ALX,blx) ____________________________________

 template<typename ALX, typename blx>
 friend
   typename
   enable_if<is_cscalar<typename decay<decltype(declval<blx>())
                                     >::type
                      >::value,
   vu2<typename decay<decltype(declval<ALX>()/
                               declval<blx>())>::type>
            >::type
   operator/(vu2<ALX> const& a, blx const& b)               ;

// OPERATOR: /(ART,blx) ____________________________________

 template<typename ART, typename blx>
 friend
   typename
   enable_if<!is_same<typename decay<decltype(declval<ART>()/
                                              declval<blx>() )
                                    >::type,
                      ART>::value
              &&
              is_cscalar<typename decay<decltype(declval<blx>())
                                      >::type
                       >::value,
   vu2<typename decay<decltype(declval<ART>()/
                               declval<blx>())>::type>
            >::type
   operator/(vu2<ART> && a, blx const& b)                   ;

// OPERATOR: /(ARW,blx) ____________________________________

 template<typename ARW, typename blx>
 friend
   typename
   enable_if<is_same<typename decay<decltype(declval<ARW>()/
                                             declval<blx>() )
                                   >::type,
                     ARW>::value
             &&
             is_cscalar<typename decay<decltype(declval<blx>())
                                     >::type
                      >::value,
             vu2<ARW>
            >::type&&
   operator/(vu2<ARW> && a, blx const& b)                   ;

// OPERATOR: /=

 template<typename ALX, typename blx>
 friend
   typename
   enable_if<is_cscalar<typename decay<decltype(declval<blx>())
                                     >::type
                      >::value,
             blx>::type&
   operator/=(vu2<ALX>& a, blx& b)                          ;

 template<typename ALX, typename brx>
 friend
   typename
   enable_if<is_cscalar<typename decay<decltype(declval<brx>())
                                     >::type
                      >::value,
             brx>::type&&
   operator/=(vu2<ALX>& a, brx && b)                        ;

