

// OPERATOR: -(ART,BRT) ____________________________________

   // non-existent for scalar-scalar


// OPERATOR: -(ALX,BLX) ____________________________________

 template<typename ALX, typename BLX>
 friend
   cpx<typename decay<decltype(declval<ALX>()-
                               declval<BLX>())>::type>
   operator-(cpx<ALX> const& a, cpx<BLX> const& b)          ;

// OPERATOR: -(ALX,BRW) ____________________________________

 template<typename ALX, typename BRW>
 friend
   typename
   enable_if<is_same<typename decay<decltype(declval<ALX>()-
                                             declval<BRW>() )
                                   >::type,
                     BRW>::value,
             cpx<BRW>
            >::type&&
   operator-(cpx<ALX> const& a, cpx<BRW> && b)              ;

// OPERATOR: -(ALX,BRT) ____________________________________

 template<typename ALX, typename BRT>
 friend
   typename
   enable_if<!is_same<typename decay<decltype(declval<ALX>()-
                                              declval<BRT>() )
                                    >::type,
                      BRT>::value,
              cpx<ALX>
            >::type
   operator-(cpx<ALX> const& a, cpx<BRT> && b)              ;

// OPERATOR: -(ARW,BLX) ____________________________________

 template<typename ARW, typename BLX>
 friend
   typename
   enable_if<is_same<typename decay<decltype(declval<ARW>()-
                                             declval<BLX>() )
                                   >::type,
                     ARW>::value,
             cpx<ARW>
            >::type&&
   operator-(cpx<ARW> && a, cpx<BLX> const& b)              ;

// OPERATOR: -(ART,BLX) ____________________________________

 template<typename ART, typename BLX>
 friend
   typename
   enable_if<!is_same<typename decay<decltype(declval<ART>()-
                                              declval<BLX>() )
                                    >::type,
                      ART>::value,
             cpx<BLX>
            >::type
   operator-(cpx<ART> && a, cpx<BLX> const& b)              ;

// OPERATOR: -(ARW,BRX) ____________________________________

 template<typename ARW, typename BRX>
 friend
   typename
   enable_if<is_same<typename decay<decltype(declval<ARW>()-
                                             declval<BRX>() )
                                   >::type,
                     ARW>::value,
             cpx<ARW>
            >::type&&
   operator-(cpx<ARW> && a, cpx<BRX> && b)                  ;

// OPERATOR: -(ART,BRW) ____________________________________

 template<typename ART, typename BRW>
 friend
   typename
   enable_if<is_same<typename decay<decltype(declval<ART>()-
                                             declval<BRW>() )
                                   >::type,
                     BRW>::value
             &&
            !is_same<typename decay<decltype(declval<ART>()-
                                             declval<BRW>() )
                                   >::type,
                     ART>::value,
             cpx<BRW>
            >::type&&
   operator-(cpx<ART> && a, cpx<BRW> && b)                  ;

// OPERATOR: -(alx,BLX) ____________________________________

 template<typename alx, typename BLX>
 friend
   typename
   enable_if<is_arithmetic<typename decay<decltype(declval<alx>())
                                         >::type
                          >::value,
   cpx<typename decay<decltype(declval<alx>()-
                               declval<BLX>())>::type>
            >::type
   operator-(alx const& a, cpx<BLX> const& b)               ;

// OPERATOR: -(alx,BRT) ____________________________________

 template<typename alx, typename BRT>
 friend
   typename
   enable_if<!is_same<typename decay<decltype(declval<alx>()-
                                              declval<BRT>() )
                                    >::type,
                      BRT>::value
              &&
              is_arithmetic<typename decay<decltype(declval<alx>())
                                         >::type
                          >::value,
             cpx<alx>
            >::type
   operator-(alx const& a, cpx<BRT>&& b)                    ;

// OPERATOR: -(alx,BRW) ____________________________________

 template<typename alx, typename BRW>
 friend
   typename
   enable_if<is_same<typename decay<decltype(declval<alx>()-
                                             declval<BRW>() )
                                   >::type,
                     BRW>::value
             &&
             is_arithmetic<typename decay<decltype(declval<alx>())
                                         >::type
                          >::value,
             cpx<BRW>
            >::type&&
   operator-(alx const& a, cpx<BRW>&& b)                    ;

// OPERATOR: -(ALX,blx) ____________________________________

 template<typename ALX, typename blx>
 friend
   typename
   enable_if<is_arithmetic<typename decay<decltype(declval<blx>())
                                         >::type
                          >::value,
   cpx<typename decay<decltype(declval<ALX>()-
                               declval<blx>())>::type>
            >::type
   operator-(cpx<ALX> const& a, blx const& b)               ;

// OPERATOR: -(ART,blx) ____________________________________

 template<typename ART, typename blx>
 friend
   typename
   enable_if<!is_same<typename decay<decltype(declval<ART>()-
                                              declval<blx>() )
                                    >::type,
                      ART>::value
              &&
              is_arithmetic<typename decay<decltype(declval<blx>())
                                          >::type
                           >::value,
             cpx<blx>
            >::type
   operator-(cpx<ART> && a, blx const& b)                   ;

// OPERATOR: -(ARW,blx) ____________________________________

 template<typename ARW, typename blx>
 friend
   typename
   enable_if<is_same<typename decay<decltype(declval<ARW>()-
                                             declval<blx>() )
                                   >::type,
                     ARW>::value
             &&
             is_arithmetic<typename decay<decltype(declval<blx>())
                                         >::type
                          >::value,
             cpx<ARW>
            >::type&&
   operator-(cpx<ARW> && a, blx const& b)                   ;

// OPERATOR: -=

 template<typename ALX, typename BLX>
 friend
   cpx<BLX>&
   operator-=(cpx<ALX>& a, cpx<BLX>& b)                     ;

 template<typename ALX, typename BRX>
 friend
   cpx<BRX>&&
   operator-=(cpx<ALX>& a, cpx<BRX> && b)                   ;

 template<typename ALX, typename blx>
 friend
   typename
   enable_if<is_arithmetic<typename decay<decltype(declval<blx>())
                                         >::type
                          >::value,
             blx>::type&
   operator-=(cpx<ALX>& a, blx& b)                          ;

 template<typename ALX, typename brx>
 friend
   typename
   enable_if<is_arithmetic<typename decay<decltype(declval<brx>())
                                         >::type
                          >::value,
             brx>::type&&
   operator-=(cpx<ALX>& a, brx && b)                        ;

 template<typename alx, typename BLX>
 friend
   typename
   enable_if<is_arithmetic<typename decay<decltype(declval<alx>())
                                         >::type
                          >::value,
             cpx<BLX>>::type&
   operator-=(alx& a, cpx<BLX>& b)                          ;

 template<typename alx, typename BRX>
 friend
   typename
   enable_if<is_arithmetic<typename decay<decltype(declval<alx>())
                                         >::type
                          >::value,
             cpx<BRX>>::type&&
   operator-=(alx& a, cpx<BRX>&& b)                         ;

