
#include <cmath>
#include <iostream>

#include "dxf.hh"
#include "cpx.hh"
#include "vu2.hh"

using namespace std                                           ;
using namespace dxf4                                          ;
using namespace cpx4                                          ;
using namespace vu24                                          ;

int main()
{
   using dtype = float                                        ;
   int   NN    = 10000                                        ;

   // ... define + fill vec with data

   auto vec = new vu2<cpx<dtype>>[NN]                         ;

   // ... define output vectors

   auto csx = new vu2<cpx<dtype>>[NN]                         ;
   auto snx = new vu2<cpx<dtype>>[NN]                         ;

   // ... call filter

   dxf filter(0.30, 0.2, vec, csx, snx, 100, "F5")            ;

   // ... print filter parameters

   cout << filter                                             ;


}

