
#include <cmath>
#include <iostream>

#include "cpx.hh"
#include "su2.hh"

using namespace std                                           ;
using namespace cpx4                                          ;
using namespace su24                                          ;

int main()
{
   using atype = float                                        ;
   using btype = cpx<int>                                     ;

   auto i = btype(0,1)                                        ;

   auto sx = su2<atype>(0, 1, 
                        1, 0)                                 ;
   auto sy = su2<btype>(0, -i, 
                        i,  0)                                ;

   auto sum = sx+sy                                           ;

   cout << boolalpha << sum << endl                           ;

   // ... observe the type calculation that takes place
   //     these objects you have in the tool-kit are smart

}

