
// OPERATOR: *(alx,BLX) ____________________________________

 template<typename alx, typename BLX>
 friend
   typename
   enable_if<is_cscalar<typename decay<decltype(declval<alx>())
                                     >::type
                      >::value,
   vu2<typename decay<decltype(declval<alx>()*
                               declval<BLX>())>::type>
            >::type
   operator*(alx const& a, vu2<BLX> const& b)               ;

// OPERATOR: *(alx,BRT) ____________________________________

 template<typename alx, typename BRT>
 friend
   typename
   enable_if<!is_same<typename decay<decltype(declval<alx>()*
                                              declval<BRT>() )
                                    >::type,
                      BRT>::value
              &&
              is_cscalar<typename decay<decltype(declval<alx>())
                                      >::type
                       >::value,
   vu2<typename decay<decltype(declval<alx>()*
                               declval<BRT>())>::type>
            >::type
   operator*(alx const& a, vu2<BRT>&& b)                    ;

// OPERATOR: *(alx,BRW) ____________________________________

 template<typename alx, typename BRW>
 friend
   typename
   enable_if<is_same<typename decay<decltype(declval<alx>()*
                                             declval<BRW>() )
                                   >::type,
                     BRW>::value
             &&
             is_cscalar<typename decay<decltype(declval<alx>())
                                     >::type
                      >::value,
             vu2<BRW>
            >::type&&
   operator*(alx const& a, vu2<BRW>&& b)                    ;

// OPERATOR: *(ALX,blx) ____________________________________

 template<typename ALX, typename blx>
 friend
   typename
   enable_if<is_cscalar<typename decay<decltype(declval<blx>())
                                     >::type
                      >::value,
   vu2<typename decay<decltype(declval<ALX>()*
                               declval<blx>())>::type>
            >::type
   operator*(vu2<ALX> const& a, blx const& b)               ;

// OPERATOR: *(ART,blx) ____________________________________

 template<typename ART, typename blx>
 friend
   typename
   enable_if<!is_same<typename decay<decltype(declval<ART>()*
                                              declval<blx>() )
                                    >::type,
                      ART>::value
              &&
              is_cscalar<typename decay<decltype(declval<blx>())
                                      >::type
                       >::value,
   vu2<typename decay<decltype(declval<ART>()*
                               declval<blx>())>::type>
            >::type
   operator*(vu2<ART> && a, blx const& b)                   ;

// OPERATOR: *(ARW,blx) ____________________________________

 template<typename ARW, typename blx>
 friend
   typename
   enable_if<is_same<typename decay<decltype(declval<ARW>()*
                                             declval<blx>() )
                                   >::type,
                     ARW>::value
             &&
             is_cscalar<typename decay<decltype(declval<blx>())
                                     >::type
                      >::value,
             vu2<ARW>
            >::type&&
   operator*(vu2<ARW> && a, blx const& b)                   ;

// OPERATOR: *=

 template<typename ALX, typename blx>
 friend
   typename
   enable_if<is_cscalar<typename decay<decltype(declval<blx>())
                                     >::type
                      >::value,
             blx>::type&
   operator*=(vu2<ALX>& a, blx& b)                          ;


 template<typename ALX, typename brx>
 friend
   typename
   enable_if<is_cscalar<typename decay<decltype(declval<brx>())
                                     >::type
                      >::value,
             brx>::type&&
   operator*=(vu2<ALX>& a, brx && b)                        ;


 template<typename alx, typename BLX>
 friend
   typename
   enable_if<is_cscalar<typename decay<decltype(declval<alx>())
                                     >::type
                      >::value,
             vu2<BLX>>::type&
   operator*=(alx& a, vu2<BLX>& b)                          ;


 template<typename alx, typename BRX>
 friend
   typename
   enable_if<is_cscalar<typename decay<decltype(declval<alx>())
                                     >::type
                      >::value,
             vu2<BRX>>::type&&
   operator*=(alx& a, vu2<BRX>&& b)                         ;

